/*-------------------------------------------------------
 *
 * $Id: Pg.xs,v 1.4 1995/07/01 20:01:36 li00357 Exp li00357 $
 *
 *-------------------------------------------------------*/

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "libpq-fe.h"


extern char *PQhost;
extern char *PQport;
extern char *PQtty;
extern char *PQoption;
extern char  PQdatabase[NameLength+1];
extern int   PQportset;
extern int   PQxactid;
extern int   PQtracep;
extern int   PQAsyncNotifyWaiting;
/*
extern char  PQerrormsg[error_msg_length];  from libpq/libpq.h
*/


MODULE = Pg	PACKAGE = Pg




char *
PQdb()


void
PQsetdb(dbname)
	char *	dbname


void
PQreset()


void
PQfinish()


char *
PQexec(query)
	char *	query




void
PQtrace()


void
PQuntrace()


int
PQnportals(rule_p)
	int	rule_p


void
PQpnames(rule_p)
	int	rule_p
	PPCODE:
	{
	    int i, num_portals ;
	    char *ptr, *portal_names, **portal_array ;
	    num_portals = PQnportals(rule_p) ;
	    if (num_portals) {
	        portal_array = (char **) calloc(num_portals, sizeof(char *)) ;
	        portal_names = (char *)  calloc(num_portals, PortalNameLength + 1) ;
	        ptr = portal_names ;
	        for (i = 0 ; i < num_portals ; i++) {
	            portal_array[i] = ptr ;
	            ptr += PortalNameLength + 1 ;
	        }
	        PQpnames(portal_array, rule_p) ;
	        EXTEND(sp, num_portals) ;
	        for (i = 0 ; i < num_portals ; i++) {
	            PUSHs(sv_2mortal(newSVpv((char*)portal_array[i], strlen(portal_array[i])))) ;
	        }
	        free(portal_array) ;
	        free(portal_names) ;
	    }
	    else {
	        ST(0) = sv_newmortal() ;
	    }
	}


PortalBuffer *
PQparray(pname)
	char *	pname


int
PQrulep(portal)
	PortalBuffer *	portal


int
PQntuples(portal)
	PortalBuffer *	portal


int
PQninstances(portal)
	PortalBuffer *	portal


int
PQngroups(portal)
	PortalBuffer *	portal


int
PQntuplesGroup(portal, group_index)
	PortalBuffer *	portal
	int	group_index


int
PQninstancesGroup(portal, group_index)
	PortalBuffer *	portal
	int	group_index


int
PQnfieldsGroup(portal, group_index)
	PortalBuffer *	portal
	int	group_index


int
PQfnumberGroup(portal, group_index, field_name)
	PortalBuffer *	portal
	int	group_index
	char *	field_name


char *
PQfnameGroup(portal, group_index, field_number)
	PortalBuffer *	portal
	int	group_index
	int	field_number


int
PQftypeGroup(portal, group_index, field_number)
	PortalBuffer *	portal
	int	group_index
	int	field_number


int
PQfsizeGroup(portal, group_index, field_number)
	PortalBuffer *	portal
	int	group_index
	int	field_number


GroupBuffer *
PQgroup(portal, tuple_index)
	PortalBuffer *	portal
	int	tuple_index


int
PQgetgroup(portal, tuple_index)
	PortalBuffer *	portal
	int	tuple_index


int
PQnfields(portal, tuple_index)
	PortalBuffer *	portal
	int	tuple_index


int
PQfnumber(portal, tuple_index, field_name)
	PortalBuffer *	portal
	int	tuple_index
	char *	field_name


char *
PQfname(portal, tuple_index, field_number)
	PortalBuffer *	portal
	int	tuple_index
	int	field_number


int
PQftype(portal, tuple_index, field_number)
	PortalBuffer *	portal
	int	tuple_index
	int	field_number


int
PQfsize(portal, tuple_index, field_number)
	PortalBuffer *	portal
	int	tuple_index
	int	field_number


int
PQsametype(portal, tuple_index1, tuple_index2)
	PortalBuffer *	portal
	int	tuple_index1
	int	tuple_index2


char *
PQgetvalue(portal, tuple_index, field_number)
	PortalBuffer *	portal
	int	tuple_index
	int	field_number


char *
PQgetAttr(portal, tuple_index, field_number)
	PortalBuffer *	portal
	int	tuple_index
	int	field_number


int
PQgetlength(portal, tuple_index, field_number)
	PortalBuffer *	portal
	int	tuple_index
	int	field_number


void
PQclear(pname)
	char *	pname


void
PQcleanNotify()


void
PQnotifies_init()


PQNotifyList *
PQnotifies()


void
PQremoveNotify(nPtr)
	PQNotifyList *	nPtr


void
PQappendNotify(relname, pid)
	char *	relname
	int	pid


void
PQgetline(length)
	int	length
	PPCODE:
	{
	    int ret ;
	    char * string = (char *)  calloc(1, length + 1) ;
	    ret = PQgetline( string, length ) ;
	    EXTEND(sp, 2) ;
	    PUSHs(sv_2mortal(newSVnv(ret))) ;
	    PUSHs(sv_2mortal(newSVpv((char*)string, strlen(string)))) ;
	    free(string) ;
	}


int
PQputline(string)
	char *	string


int
PQendcopy()





char *
PQhost()
	CODE:
	    RETVAL = PQhost;
	OUTPUT:
	    RETVAL


char *
PQport()
	CODE:
	    RETVAL = PQport;
	OUTPUT:
	    RETVAL


char *
PQtty()
	CODE:
	    RETVAL = PQtty;
	OUTPUT:
	    RETVAL


char *
PQoption()
	CODE:
	    RETVAL = PQoption;
	OUTPUT:
	    RETVAL


char *
PQdatabase()
	CODE:
	    RETVAL = PQdatabase;
	OUTPUT:
	    RETVAL


int
PQportset()
	CODE:
	    RETVAL = PQportset;
	OUTPUT:
	    RETVAL


int
PQxactid()
	CODE:
	    RETVAL = PQxactid;
	OUTPUT:
	    RETVAL


int
PQtracep()
	CODE:
	    RETVAL = PQtracep;
	OUTPUT:
	    RETVAL


int
PQAsyncNotifyWaiting()
	CODE:
	    RETVAL = PQAsyncNotifyWaiting;
	OUTPUT:
	    RETVAL


char *
PQerrormsg()
	CODE:
	    RETVAL = PQerrormsg;
	OUTPUT:
	    RETVAL


